<template>
	<a-card :bordered="false">
		<a-form ref="searchFormRef" name="advanced_search" :model="searchFormState" class="ant-advanced-search-form mb-4">
			<a-row :gutter="24">
				<a-col :span="4">
					<a-form-item label="企业客户" name="depotId">
						<a-select v-model:value="searchFormState.depotId" placeholder="请选择企业客户" :options="depotOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="4">
					<a-form-item label="是否异常" name="alarmFlag">
						<a-select v-model:value="searchFormState.alarmFlag" placeholder="请选择是否异常" :options="alarmFlagOptions"/>
					</a-form-item>
				</a-col>
				<a-col :span="6">
					<a-button type="primary" @click="table.refresh(true)">查询</a-button>
					<a-button style="margin: 0 8px" @click="() => searchFormRef.resetFields()">重置</a-button>
					<!--					<a @click="toggleAdvanced" style="margin-left: 8px">
										{{ advanced ? '收起' : '展开' }}
										<component :is="advanced ? 'up-outlined' : 'down-outlined'"/>
									</a>-->
				</a-col>
			</a-row>
		</a-form>
		<s-table
			ref="table"
			:columns="columns"
			:data="loadData"
			:alert="options.alert.show"
			bordered
			:row-key="(record) => record.id"
			:tool-config="toolConfig"
			:row-selection="options.rowSelection"
		>
			<template #operator class="table-operator">
				<a-space>
					<!--					<a-button type="primary" @click="formRef.onOpen()" v-if="hasPerm('depotUserOnlineLogAdd')">
										<template #icon>
											<plus-outlined/>
										</template>
										新增
									</a-button>-->
					<a-button type="primary" @click="exportTable()"><export-outlined/>导出</a-button>
					<a-button danger @click="deleteBatchDepotUserOnlineLog()" v-if="hasPerm('depotUserOnlineLogBatchDelete')">删除</a-button>
				</a-space>
			</template>
			<template #bodyCell="{ column, record }">
				<template v-if="column.dataIndex === 'onlinePicUrl'">
					<a v-if="record.onlinePicUrl" :href="record.onlinePicUrl" target="_blank">
						<img :src="record.onlinePicUrl" class="record-img" style="max-height: 50px; max-width: 50px"/>
					</a>
				</template>
				<template v-if="column.dataIndex === 'action'">
					<a @click="formRef.onOpen(record)" v-if="hasPerm('depotUserOnlineLogEdit')">编辑</a>
					<a-divider type="vertical" v-if="hasPerm(['depotUserOnlineLogEdit', 'depotUserOnlineLogDelete'], 'and')"/>
					<a-popconfirm title="确定要删除吗？" @confirm="deleteDepotUserOnlineLog(record)">
						<a-button type="link" danger size="small" v-if="hasPerm('depotUserOnlineLogDelete')">删除</a-button>
					</a-popconfirm>
				</template>
			</template>
		</s-table>
	</a-card>
	<Form ref="formRef" @successful="table.refresh(true)"/>
</template>

<script setup name="depotUserOnlineLog">
import {message} from 'ant-design-vue'
import tool from '@/utils/tool'
import Form from './form.vue'
import depotUserOnlineLogApi from '@/api/biz/depotUserOnlineLogApi'
import dictOptionsApi from "@/api/biz/dictOptionsApi";
import * as XLSX from "xlsx";
import moment from "moment";

let searchFormState = reactive({})
const searchFormRef = ref()
const table = ref()
const formRef = ref()
const depotOptions = ref([])
const toolConfig = {refresh: true, height: true, columnSetting: true, striped: false}
// 查询区域显示更多控制
const advanced = ref(false)
const toggleAdvanced = () => {
	advanced.value = !advanced.value
}
const columns = [
	{
		title: '企业客户',
		dataIndex: 'depotGrainName'
	},
	{
		title: '用户',
		dataIndex: 'createUserName'
	},
	{
		title: '签到照片',
		dataIndex: 'onlinePicUrl',
	},
	{
		title: '是否异常',
		dataIndex: 'alarmFlag'
	},
	{
		title: '时间',
		dataIndex: 'createTime'
	},
]
// 操作栏通过权限判断是否显示
if (hasPerm(['depotUserOnlineLogEdit', 'depotUserOnlineLogDelete'])) {
	columns.push({
		title: '操作',
		dataIndex: 'action',
		align: 'center',
		width: '150px'
	})
}
let selectedRowKeys = ref([])
// 列表选择配置
const options = {
	alert: {
		show: false,
		clear: () => {
			selectedRowKeys = ref([])
		}
	},
	rowSelection: {
		onChange: (selectedRowKey, selectedRows) => {
			selectedRowKeys.value = selectedRowKey
		}
	}
}
dictOptionsApi.options(Object.assign('', {'dictValue': '粮库'})).then((data) => {
	depotOptions.value = data
})
let loadDataLst
const loadData = (parameter) => {
	const searchFormParam = JSON.parse(JSON.stringify(searchFormState))
	return depotUserOnlineLogApi.depotUserOnlineLogPage(Object.assign(parameter, searchFormParam)).then((data) => {
		loadDataLst = data.records
		return data
	})
}
// 删除
const deleteDepotUserOnlineLog = (record) => {
	let params = [
		{
			id: record.id
		}
	]
	depotUserOnlineLogApi.depotUserOnlineLogDelete(params).then(() => {
		table.value.refresh(true)
	})
}
// 批量删除
const deleteBatchDepotUserOnlineLog = () => {
	if (selectedRowKeys.value.length < 1) {
		message.warning('请选择一条或多条数据')
		return false
	}
	const params = selectedRowKeys.value.map((m) => {
		return {
			id: m
		}
	})
	depotUserOnlineLogApi.depotUserOnlineLogDelete(params).then(() => {
		table.value.clearRefreshSelected()
	})
}
// 导出
const exportTable = () => {
	let tableData = [['企业客户', '名称',  '是否异常','时间']]
	let idStr = ''
	if (selectedRowKeys.value.length > 0) {
		selectedRowKeys.value.map((m) => {
			idStr = idStr + ',' + m
		})
	}
	loadDataLst.map((m) => {
		if (!idStr || idStr.indexOf(m.id) > 0)
			tableData.push([m.depotGrainName, m.createUserName, m.alarmFlag, m.createTime])
	})
	let workSheet = XLSX.utils.aoa_to_sheet(tableData)
	let bookNew = XLSX.utils.book_new()
	XLSX.utils.book_append_sheet(bookNew, workSheet, 'Sheet1')
	let name = '人员签到' + moment().format('_YYYY-MM-DD') + '.xlsx'
	XLSX.writeFile(bookNew, name)
}
const alarmFlagOptions = tool.dictList('是否判断')
</script>
